-- MasterLootNWOP.lua
-- Author: KiLLerBoy_001

local ClassesByTokenID = {
	-- Tier 20 
	-- Chests
	["147316"] = {4,6,8,11,99},
	["147317"] = {2,5,9,12,99},
	["147318"] = {1,3,7,10,99},
	--	Gauntlets 
	["147319"] = {4,6,8,11,99},
	["147320"] = {2,5,9,12,99},
	["147321"] = {1,3,7,10,99},
	--	Helm  
	["147322"] = {4,6,8,11,99},
	["147323"] = {2,5,9,12,99},
	["147324"] = {1,3,7,10,99},
	-- Leggings
	["147325"] = {4,6,8,11,99},
	["147326"] = {2,5,9,12,99},
	["147327"] = {1,3,7,10,99},
	-- Shoulders 
	["147328"] = {4,6,8,11,99},
	["147329"] = {2,5,9,12,99},
	["147330"] = {1,3,7,10,99},
	-- Cloaks 
	["147331"] = {4,6,8,11,99},
	["147332"] = {2,5,9,12,99},
	["147333"] = {1,3,7,10,99},
}

local SlotByTokenID = {
	-- Tier 20 
	-- Chests
	["147316"] = 5,
	["147317"] = 5,
	["147318"] = 5,
	--	Gauntlets 
	["147319"] = 10,
	["147320"] = 10,
	["147321"] = 10,
	--	Helm  
	["147322"] = 1,
	["147323"] = 1,
	["147324"] = 1,
	-- Leggings
	["147325"] = 7,
	["147326"] = 7,
	["147327"] = 7,
	-- Shoulders 
	["147328"] = 3,
	["147329"] = 3,
	["147330"] = 3,
	-- Cloaks 
	["147331"] = 15,
	["147332"] = 15,
	["147333"] = 15,
}


local config = CreateFrame("Frame")
GlobalItemLink = ""
Name = ""
FiredOnce = false
Timer = 1

local function GetSlotID(itemEquipLoc,itemType)
	if itemEquipLoc == 'INVTYPE_HEAD' then return 1
	elseif itemEquipLoc == 'INVTYPE_NECK' then return 2
	elseif itemEquipLoc == 'INVTYPE_SHOULDER' then return 3
	elseif itemEquipLoc == 'BODY' then return 4
	elseif itemEquipLoc == 'INVTYPE_CHEST' then return 5
	elseif itemEquipLoc == 'INVTYPE_ROBE' then return 5
	elseif itemEquipLoc == 'INVTYPE_WAIST' then return 6
	elseif itemEquipLoc == 'INVTYPE_LEGS' then return 7
	elseif itemEquipLoc == 'INVTYPE_FEET' then return 8
	elseif itemEquipLoc == 'INVTYPE_WRIST' then return 9
	elseif itemEquipLoc == 'INVTYPE_HAND' then return 10
	elseif itemEquipLoc == 'INVTYPE_FINGER' then return 11 -- and 12
	elseif itemEquipLoc == 'INVTYPE_TRINKET' then return 13 -- and 14
	elseif itemEquipLoc == 'INVTYPE_CLOAK' then return 15
	elseif itemEquipLoc == 'INVTYPE_WEAPON' then return 16
	elseif itemEquipLoc == 'INVTYPE_SHIELD' then return 17
	elseif itemEquipLoc == 'INVTYPE_2HWEAPON' then return 16
	elseif itemEquipLoc == 'INVTYPE_WEAPONMAINHAND' then return 16
	elseif itemEquipLoc == 'INVTYPE_WEAPONOFFHAND' then return 17
	elseif itemEquipLoc == 'INVTYPE_HOLDABLE' then return 17
	elseif itemEquipLoc == 'INVTYPE_RANGED' then return 16
	elseif itemEquipLoc == 'INVTYPE_THROWN' then return 16
	elseif itemEquipLoc == 'INVTYPE_RANGEDRIGHT' then return 16
	elseif itemEquipLoc == 'INVTYPE_RELIC' then return 18 --needs something else 
	elseif itemType =='Gem' then return 18 --needs something else
	else return nil
	end
end

local function ItemLinkToID(Linky)
local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4,
    Suffix, Unique, LinkLvl, Name = string.find(Linky,
    "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
	return Id
end

local MainFrameDesign = {
  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",  
  edgeFile = "Interface\\FriendsFrame\\UI-Toast-Border",
  tile = true,
  tileSize = 16,
  edgeSize = 8,
  insets = {
    left = 4,
    right = 4,
    top = 4,
    bottom = 4
  }
}

local NWOPMain = CreateFrame("Frame", "NGOP", UIParent)
NWOPMain:SetSize(280, 105);
NWOPMain:SetPoint("BOTTOM", 0, 250)
NWOPMain:SetFrameStrata("TOOLTIP");
NWOPMain:EnableMouse(true)
NWOPMain:SetBackdrop(MainFrameDesign) 
NWOPMain:SetMovable(true)
NWOPMain:RegisterForDrag("LeftButton")
NWOPMain:SetScript("OnDragStart", function(self) NWOPMain:StartMoving() end)
NWOPMain:SetScript("OnDragStop", function(self) NWOPMain:StopMovingOrSizing() end)
NWOPMain:SetScript("OnEnter", function() Tooltip_OnEnter() end)
NWOPMain:SetScript("OnLeave", function() Tooltip_OnLeave() end)
NWOPMain:Hide()

local function Want()
	name, realm = UnitName("player")
	RandomRoll(1,100)
	NWOPMain:Hide()
end

local function GetItemLevelIncreaseforRelic(LinkorID)
	_, _, _, itemLevel, _, _, _, _, _, _, _ =GetItemInfo(LinkorID)
	print(itemLevel)
	local var=(((itemLevel/5)-(710/5))*1.5+1)
	var = math.floor(var) 
	print(var)
	return var 
end

local function isToken(Link)
	local Bool = false
	local ID = ItemLinkToID(Link)
	local Classes = ClassesByTokenID[ID]
	if Classes~=nil and Classes[5] == 99 then
		Bool = true  
	end
	return Bool
end

local function isTokenForMe(Link)
	local Bool = false
	local ID = ItemLinkToID(Link)
	local Classes = ClassesByTokenID[ID]
	local _, _, classIndex = UnitClass("player")
	for i = 1, 4 do
		if Classes~=nil and Classes[i] == classIndex then
			Bool = true  
		end
	end
	if Bool == false then 
		print("|cFFD4AF37NWOP:|cFFE3DEDB Auto Passed - "..Link.." - |cFF50C878Icompatible")
	end
	return Bool
end

local function Need()
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(GlobalItemLink)
    local slotID = GetSlotID(itemEquipLoc,itemType)
	local Token = isTokenForMe(GlobalItemLink)
	if Token then
		local ID = ItemLinkToID(GlobalItemLink)
		slotID = SlotByTokenID[ID]
	end
	if slotID == 18 then 
		local WeaponID = ItemLinkToID(GetInventoryItemLink("player",16))
		local NewRelicID = ItemLinkToID(GlobalItemLink)
		
			
		if ArtifactFrame and ArtifactFrame:IsVisible() then -- Open frame if required 
			var = true
		else
			var = false 
			SocketInventoryItem(16)
		end
		
		local NewRelicName, NewRelicIcon, NewRelicType, NewRelicLink = C_ArtifactUI.GetRelicInfoByItemID(ItemLinkToID(GlobalItemLink));
		local NewPowers = C_ArtifactUI.GetPowersAffectedByRelicItemLink(NewRelicLink)
		local NewSpellLink = C_ArtifactUI.GetPowerHyperlink(NewPowers)
		
		for relicSlotIndex = 1, C_ArtifactUI.GetNumRelicSlots() do
			if C_ArtifactUI.CanApplyRelicItemIDToSlot(NewRelicID, relicSlotIndex) then
				CurRelicName, CurRelicIcon, CurRelicType, CurRelicLink = C_ArtifactUI.GetEquippedArtifactRelicInfo(relicSlotIndex) --GetRelicInfo(relicSlotIndex)
				--CurPowers = C_ArtifactUI.GetPowersAffectedByRelicItemLink(CurrelicLink)
				CurPowers = C_ArtifactUI.GetPowersAffectedByRelic(relicSlotIndex)
				CurSpellLink = C_ArtifactUI.GetPowerHyperlink(CurPowers)
			end
		end
		
		if var==false then  -- Hide frame if required
			ArtifactFrame:Hide()
		end
		
		print("From: "..CurSpellLink.."  To: "..NewSpellLink) -- if this works then FML and ill get rid of extra addon lua etc		
		
		local Currentlevel = GetItemLevelIncreaseforRelic(CurRelicLink) 
		local NewLevel = GetItemLevelIncreaseforRelic(GlobalItemLink) 
		level = NewLevel-Currentlevel 
		
		if level > 0 then 
			PosNeg = "+"
		else
			PosNeg = ""
		end
		
		SendChatMessage("Need: "..PosNeg..level.."   "..NewSpellLink, "RAID")
	elseif slotID == 11 then 
		Curitem = GetInventoryItemLink("player",11)
		Curitem2 = GetInventoryItemLink("player",12)
		SendChatMessage("Need: "..Curitem.." & "..Curitem2, "RAID")
	elseif slotID == 13 then 
		Curitem = GetInventoryItemLink("player",13)
		Curitem2 = GetInventoryItemLink("player",14)
		SendChatMessage("Need: "..Curitem.." & "..Curitem2, "RAID")
	else
		Curitem = GetInventoryItemLink("player",slotID)
		SendChatMessage("Need: "..Curitem, "RAID")
	end
	NWOPMain:Hide()
end


local function Pass()
	NWOPMain:Hide()
end


function Tooltip_OnEnter()
  GameTooltip_SetDefaultAnchor(GameTooltip, NWOPMain)
  GameTooltip:SetPoint("BOTTOM",NWOPMain, -300, 0)
  GameTooltip:SetHyperlink(GlobalItemLink)
  GameTooltip:Show()
end

function Tooltip_OnLeave()
  GameTooltip:Hide()
end


local TitleText = NWOPMain:CreateFontString(nil, "OVERLAY", "GameFontNormal")
TitleText:SetPoint("TOP", -28, -3)
TitleText:SetText("NWOP")
local TitleText2 = NWOPMain:CreateFontString(nil, "OVERLAY", "GameFontWhite")
TitleText2:SetPoint("TOP", 18, -3)
TitleText2:SetText("-ing for:")

local ItemText2 = NWOPMain:CreateFontString(nil, "OVERLAY", "GameFontWhite")
ItemText2:SetPoint("TOP", 0, -17)
ItemText2:SetText(GlobalItemLink)


local NeedButton = CreateFrame("Button", "NeedButton", NWOPMain)
NeedButton:SetSize(50,50);
NeedButton:SetPoint("LEFT", 20, -10)
NeedButton:SetPushedTexture("Interface\\Buttons\\UI-PlusButton-Down")
NeedButton:SetHighlightTexture("Interface\\Buttons\\UI-PlusButton-Hilight")
NeedButton:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up")
NeedButton:SetFrameStrata("TOOLTIP");
NeedButton:EnableMouse(true)
NeedButton:RegisterForClicks("AnyUp");
NeedButton:SetScript("OnMouseUp", function(self, LeftButton) Need() end)
NeedButton:SetScript("OnEnter", function() Tooltip_OnEnter() end)
NeedButton:SetScript("OnLeave", function() Tooltip_OnLeave() end)

local NeedText = NeedButton:CreateFontString(nil, "OVERLAY", "GameFontWhite")
NeedText:SetPoint("CENTER", 0, -30)
NeedText:SetText("NEED")

local WantButton = CreateFrame("Button", "WantButton", NWOPMain)
WantButton:SetSize(50,50);
WantButton:SetPoint("LEFT", 120, -10)
WantButton:SetPushedTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Down")
WantButton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Highlight")
WantButton:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Up")
WantButton:SetFrameStrata("TOOLTIP");
WantButton:EnableMouse(true)
WantButton:RegisterForClicks("AnyUp");
WantButton:SetScript("OnMouseUp", function(self, LeftButton) Want() end)
WantButton:SetScript("OnEnter", function() Tooltip_OnEnter() end)
WantButton:SetScript("OnLeave", function() Tooltip_OnLeave() end)

local WantText = WantButton:CreateFontString(nil, "OVERLAY", "GameFontWhite")
WantText:SetPoint("CENTER", 0, -30)
WantText:SetText("WANT")

local PassButton = CreateFrame("Button", "PassButton", NWOPMain)
PassButton:SetSize(50,50);
PassButton:SetPoint("LEFT", 220, -10)
PassButton:SetPushedTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Down")
PassButton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Highlight")
PassButton:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Up")
PassButton:SetFrameStrata("TOOLTIP");
PassButton:EnableMouse(true)
PassButton:RegisterForClicks("AnyUp");
PassButton:RegisterForClicks("AnyUp");
PassButton:SetScript("OnMouseUp", function(self, LeftButton) Pass() end)

local PassText = PassButton:CreateFontString(nil, "OVERLAY", "GameFontWhite")
PassText:SetPoint("CENTER", 0, -30)
PassText:SetText("PASS")


local events = {
	"CHAT_MSG_RAID_WARNING",
}


local function ShowGui()
	ItemText2:SetText(GlobalItemLink)
	NWOPMain:Show()
end

function IsTypeCompatible(NewSubType,Link,Slot)
	local GearLink = GetInventoryItemLink("player",Slot)
	if GearLink ~= nill then
		local _, _, _, _, _, _, itemSubType, _, _, _, _ = GetItemInfo(GearLink)
		if itemSubType == NewSubType then 
			return true
		else
			print("|cFFD4AF37NWOP:|cFFE3DEDB Auto Passed - "..Link.." - |cFF50C878Icompatible")
			return false
		end
	else
		print("NWOP ERROR: Could not compare armor Types")
		return false 
	end
	PriorLink = Link
end

local function FireOnce(seconds)
	if Timer==0 then 
		Timer = (GetTime()+seconds)
	end
	
	if Timer>GetTime() then --Not yet
		return false
	elseif Timer<GetTime() then --Now
		Timer=0
		return true
	end
end
		
local function CheckMessage(self, event, ...) --Check for incomming raid warnings containing itemlinks
	if FireOnce(2) then 
		if IsInRaid() then
			Method, _, MasterID = GetLootMethod()
			if true then --Method=="master" then)
				local msg, user = ...
				for itemLink in msg:gmatch("|%x+|Hitem:.-|h.-|h|r") do
					local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink)
					local slotID = GetSlotID(itemEquipLoc,itemType)
					
					local Token = isToken(itemLink)
					local TokenComp = isTokenForMe(itemLink)
					if Token == false  then 
						local Comp = IsTypeCompatible(itemSubType,itemLink,slotID)
					end
					
					GlobalItemLink = itemLink
					
					if slotID~=nil or Token then
						if slotID==18 or Comp or TokenComp then
							ShowGui()
						end
					end
				end
			end
		end
	end
end
	
	
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_WARNING", CheckMessage)
